package ui.view;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import ui.controller.Control;
import ui.model.Model;
import java.util.ArrayList;

import java.awt.GridBagLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class SimulationMenu extends JMenuBar {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	// Components
	private JPanel simMenuPanel = new JPanel();
	private JRadioButton simButton = new JRadioButton("Simulate");
	private JLabel simSpeedLabel = new JLabel("Simulation Speed:");
	private JTextField simSpeedText = new JTextField("1000");
	private JLabel algoLabel = new JLabel("Algorithm:");
	private JComboBox algoCombo;
	private ArrayList<String> algos = new ArrayList<>();

	Model model;
	Control controller;
	
	public SimulationMenu(Model mod, Control cont) {
		super();
		// Init Stuff
		this.model = mod;
		this.controller = cont;
		
		//AlgoCombobox Items
		algos.add("algorithm1");
		algos.add("algorithm2");
		algos.add("algorithm3");
		
		//timerSpeed
		simSpeedText.setMaximumSize(new Dimension(300, 300));
		simSpeedText.addCaretListener(new CaretListener() {
			@Override
			public void caretUpdate(CaretEvent e) {
				try {
					controller.setTimerSpeed(Integer.parseInt(simSpeedText.getText()));
				} catch (Exception e2) {
					// TODO: handle exception
				}
				
			}
		});
		
		//isSimulation
		simButton.addPropertyChangeListener(new PropertyChangeListener() {
			
			@Override
			public void propertyChange(PropertyChangeEvent evt) {
				controller.setIsSimulation(simButton.isSelected());
			}
		});
		
		// Add to Panel
		JPanel menuPanel = new JPanel();
		GridBagLayout gbl_t = new GridBagLayout();
		gbl_t.columnWidths = new int[] { 79, 109, 46, 64, 31, 0 };
		gbl_t.rowHeights = new int[] { 25, 0 };
		gbl_t.columnWeights = new double[] { 0.0, 0.0, 0.0, 0.0, 0.0, Double.MIN_VALUE };
		gbl_t.rowWeights = new double[] { 0.0, Double.MIN_VALUE };
		menuPanel.setLayout(gbl_t);

		GridBagConstraints gbc_simButton = new GridBagConstraints();
		gbc_simButton.anchor = GridBagConstraints.NORTHWEST;
		gbc_simButton.insets = new Insets(0, 0, 0, 5);
		gbc_simButton.gridx = 0;
		gbc_simButton.gridy = 0;
		menuPanel.add(simButton, gbc_simButton);
		GridBagConstraints gbc_simSpeedLabel = new GridBagConstraints();
		gbc_simSpeedLabel.anchor = GridBagConstraints.WEST;
		gbc_simSpeedLabel.insets = new Insets(0, 0, 0, 5);
		gbc_simSpeedLabel.gridx = 1;
		gbc_simSpeedLabel.gridy = 0;
		menuPanel.add(simSpeedLabel, gbc_simSpeedLabel);
		GridBagConstraints gbc_simSpeedText = new GridBagConstraints();
		gbc_simSpeedText.anchor = GridBagConstraints.WEST;
		gbc_simSpeedText.insets = new Insets(0, 0, 0, 5);
		gbc_simSpeedText.gridx = 2;
		gbc_simSpeedText.gridy = 0;
		menuPanel.add(simSpeedText, gbc_simSpeedText);
		GridBagConstraints gbc_algoLabel = new GridBagConstraints();
		gbc_algoLabel.anchor = GridBagConstraints.WEST;
		gbc_algoLabel.insets = new Insets(0, 0, 0, 5);
		gbc_algoLabel.gridx = 3;
		gbc_algoLabel.gridy = 0;
		menuPanel.add(algoLabel, gbc_algoLabel);

		algoCombo = new JComboBox<Object>(algos.toArray());
		GridBagConstraints gbc_algoCombo = new GridBagConstraints();
		gbc_algoCombo.anchor = GridBagConstraints.WEST;
		gbc_algoCombo.gridx = 4;
		gbc_algoCombo.gridy = 0;
		menuPanel.add(algoCombo, gbc_algoCombo);
		this.add(menuPanel);
	}
}
